/*******************************************************************************
* File Name    : AR_LIB_SHIFT.c
* Version      : Rev. 1.00
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file implements Arduino shiftin/shiftout library.
* Creation Date: 2022/05/30
********************************************************************************/

/*******************************************************************************
Includes
********************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_timer.h"
#include "r_cg_userdefine.h"
#include "AR_LIB_PORT.h"
#include "AR_LIB_SHIFT.h"

/*******************************************************************************
Pragma directive
********************************************************************************/


/*******************************************************************************
Global variables and functions
********************************************************************************/

volatile uint8_t sck_pin;                    // SCKM̒[qw肷ϐ
volatile uint8_t mosi_pin;                   // SOM̒[qw肷ϐ
volatile uint8_t miso_pin;                   // SIM̒[qw肷ϐ

/*******************************************************************************
* Function Name: shiftOut
* Description  : pEVAϊ@\iVtgENbN̗オŃb`j
* Arguments    : datapin:f[^̏o͒[qpin number( D0 - D15 )
*                clockPin:VtgENbNo͒[qpin number( D0 - D15 )
*                bitOrdeer:]  MSBFIRST:ʃrbg]
*                                  LSBFIRST:ʃrbg]
*                value:]f[^
* Return Value : none
********************************************************************************/
void shiftOut (uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder, uint8_t value)
{

    uint8_t loopc;
    uint8_t work;
    uint8_t mask;
    sck_pin = clockPin;                         // VtgENbNs̐ݒ
    mosi_pin = dataPin;                         // f[^s̐ݒ
    work = value;                               // ]f[^Zbg

    digitalWrite( sck_pin, LOW );               // SCK𗧂

    if ( MSBFIRST == bitOrder )
    {       // ʃrbg][h
        for ( mask = 0x80 ; mask > 0 ; )
        {
            digitalWrite( mosi_pin, ( work & mask ) ); // f[^o
            mask >>= 1;                         // }XNrbgXV
            digitalWrite( sck_pin, HIGH );      // SCK𗧂グ
            digitalWrite( sck_pin, LOW );       // SCK𗧂
        }
        
    }
    else
    {       // ʃrbg][h
        for ( loopc = 8 ; loopc > 0 ;  )
        {
            digitalWrite( mosi_pin, ( work & 0x01 ) ); // f[^o
            loopc--;                            // JE^XV
	    work >>= 1;				// f[^Vtg
            digitalWrite( sck_pin, HIGH );      // SCK𗧂グ
            digitalWrite( sck_pin, LOW );       // SCK𗧂
        }

    }

}


/*******************************************************************************
* Function Name: shiftIn
* Description  : VAEpϊ@\BVtgENbN̗オŎ荞
* Arguments    : datapin:f[^̓͒[qpin number( D0 - D15 )
*                clockPin:VtgENbNo͒[qpin number( D0 - D15 )
*                bitOrdeer:]  MSBFIRST:ʃrbg]
*                                  LSBFIRST:ʃrbg]
* Return Value : ǂݏof[^
********************************************************************************/
uint8_t shiftIn(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder)
{

    uint8_t work;
    uint8_t s_data;

    sck_pin = clockPin;                         // VtgENbNs̐ݒ
    miso_pin = dataPin;                         // f[^s̐ݒ

    work = 0x00;                                // Ɨp̈揉
    s_data = 0x00;                              // Mf[^
    digitalWrite( sck_pin, LOW );               // SCK𗧂

    if ( MSBFIRST == bitOrder)
    {       // ʃrbg][h
        for ( s_data = 0x80 ; s_data > 0 ; )
        {
            digitalWrite( sck_pin, HIGH );      // SCK𗧂グ

            if ( 0 != digitalRead( miso_pin ) )
            {
                work |= s_data;                 // rbgǉ
            }

            digitalWrite( sck_pin, LOW );       // SCK𗧂
            s_data >>= 1;                       // rbgʒuύX
        }
        
    }
    else
    {
        for ( s_data = 0x01 ; s_data > 0 ; )
        {
            digitalWrite( sck_pin, HIGH );      // SCK𗧂グ

            if ( 0 != digitalRead( miso_pin ) )
            {
                work |= s_data;                 // rbgǉ
            }

            digitalWrite( sck_pin, LOW );       // SCK𗧂
            s_data <<= 1;                       // rbgʒuύX
        }
        
    }

    return(work);

}

