/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2020 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G14 V2.05.05.01 [25 Nov 2020]
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2022/06/05
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
#include "r_cg_adc.h"
#include "r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
#include "AR_LIB_PORT.h"
#include "AR_LIB_TIME.h"
#include "AR_SKETCH.h"

/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */

#ifdef   IAR_ENV
/* Set option bytes */
#pragma location = "OPTBYTE"
__root const uint8_t opbyte0 = 0xEEU;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte1 = 0x7FU;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte2 = 0xE8U;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte3 = 0x85U;
#endif

extern unsigned int old_time;           /* previous time(milli sec.)*/

/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
    while (1U)
    {

        loop();                         /* execute sketch               */

    }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */

    TMR10 &= 0x800F;                    /* disable edge detection       */
    TMR11 &= 0x800F;                    /* disable edge detection       */
    TDR13 = ( 1000 -1 );                /* set interval is 1milli sec.  */
    TMIF10 = 0;                         /* clear timer interrupt flags  */
    TMIF11 = 0;
    TMIF12 = 0;
    TMIF13 = 0;
    TMMK10 = 0;                         /* enable INTTM10,11,12,13      */
    TMMK11 = 0;
    TMMK12 = 0;
    TMMK13 = 0;
    TS1 |= 0x0B;                        /* start TM13,enable TM10 & TM11*/

/*-----------------------------------------------

    analog output function setup

-----------------------------------------------*/

    TMIF00 = 0;                         /* clear interrupt request flag */
    TMMK00 = 0;                         /* enable TM00 interrupt        */
    TS0 = 0x01;                         /* TM00 start for software PWM  */

    PM1 |= 0x07;                        /* set P12,P11,P10 to input mode*/
    TRDGRB1 = TRDGRA1;                  /* set D10 PWM pin to low level */
    TRDGRC1 = TRDGRA1;                  /* set D9 PWM pin to low level  */
    TRDGRD1 = TRDGRA1;                  /* set D6 PWM pin to low level  */
    TRDSR1 = 0x00;                      /* clear TRD1 interrupt request */
    TRDMK1 = 1;                         /* disable TMRD1 interrupt      */
    TRDSTR |= 0x08;                     /* TDR1 count continues         */
    TRDSTR |= 0x02;                     /* start TMRD1 counter          */

    EI();

    do{                                 /* wait for 64ms                */
        old_time =  ( int )( millis() & 0x0FFFF );
    }while ( old_time < 64 );

    setup();                            /* Arduino init procedure       */

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
