/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2020 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/*******************************************************************************
* File Name    : AR_LIB_ANALOG.h
* Version      : Rev. 1.00
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file implements Arduino library(analog I/O).
* Creation Date: 2021/09/24
********************************************************************************/

#define     HIGH_RANGE  ( 1 )       /* port for high illumination       */
#define     LOW_RANGE   ( 0 )       /* port for low illumination        */
#define     ANALOGPin0  ( 0 )       /* analog in 0 pin                  */
#define     ANALOGPin1  ( 1 )       /* analog in 1 pin                  */
#define     ANALOGPin2  ( 2 )       /* analog in 2 pin                  */
#define     ANALOGPin3  ( 3 )       /* analog in 3 pin                  */
#define     ANALOGPin4  ( 4 )       /* analog in 4 pin                  */
#define     ANALOGPin5  ( 5 )       /* analog in 5 pin                  */

#define     DEFAULT     ( 0 )       /* analog reference is VDD          */
#define     INTERNAL    ( 1 )       /* analog reference is internal     */
#define     EXTERNAL    ( 2 )       /* analog reference is external     */

#define     HARDPWM1    ( 6 )       /* PWM signal generated by TMRD1    */
#define     HARDPWM2    ( 9 )       /* PWM signal generated by TMRC1    */
#define     HARDPWM3    ( 10 )      /* PWM signal generated by TMRB1    */
#define     SOFTPWM1    ( 3 )       /* PWM signal generated by software1*/
#define     SOFTPWM2    ( 5 )       /* PWM signal generated by software2*/
#define     SOFTPWM3    ( B )       /* PWM signal generated by software3*/


uint16_t    analogRead(uint8_t pin);    /* analog input at pin          */
uint8_t     analogWrite(uint8_t pin, uint8_t value); /* analog out      */
void        analogReference(uint8_t type);  /* select reference for A/D */
