/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2020 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/*******************************************************************************
* File Name    : AR_WIRE_DEF.h
* Version      : Rev. 1
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file defines Arduino Wire library.
* Creation Date: 2021/06/15
********************************************************************************/
#define writeFUNC(_a,_b, FUNC_NAME, ...) FUNC_NAME
#define write(...) writeFUNC(__VA_ARGS__, Wire_writeb, Wire_writec, ~)(__VA_ARGS__)

#define recFUNC(_a,_b,_c, FUNC_NAME, ...) FUNC_NAME
#define requestFrom(...) recFUNC(__VA_ARGS__, Wire_requestFrom, Wire_requestFromS, ~)(__VA_ARGS__)

/*--------------------------------------------------------------

    definition of wire API functions

---------------------------------------------------------------*/

typedef struct {
    void ( *begin )( void );                // start of wire function as master
    uint8_t ( *beginTransmission )( uint8_t );    // start transmit to slave
    uint8_t ( *Wire_writeb )(uint8_t *buff, uint8_t bytes );    // data set to transmit buffer
    uint8_t ( *Wire_writec )(uint8_t data);    // data set to transmit buffer
    uint8_t ( *endTransmission) ( uint8_t);         // end transmit to slave
    uint8_t ( *Wire_requestFrom )( uint8_t saddr7, uint16_t bytes, uint8_t stop);        // start receiving
    uint8_t ( *Wire_requestFromS )( uint8_t saddr7, uint16_t bytes);        // start receiving
    uint8_t ( *available )( void );           // check receive buffer
    uint8_t ( *read )( void );    // read received data from buffer
}API_Wire;
